<?php

namespace Drupal\xero\Plugin\DataType;

/**
 * Xero Tracking Option type for BankTransaction line items.
 *
 * @see https://developer.xero.com/documentation/api/banktransactions
 *
 * @DataType(
 *   id = "xero_tracking_option",
 *   label = @Translation("Xero Tracking Option"),
 *   definition_class = "\Drupal\xero\TypedData\Definition\TrackingOptionDefinition",
 *   list_class = "\Drupal\xero\Plugin\DataType\XeroItemList"
 * )
 */
class TrackingOption extends XeroItemBase {

  /**
   * {@inheritdoc}
   */
  public static $xero_name = 'TrackingCategory';

  /**
   * {@inheritdoc}
   */
  public static $plural_name = 'Tracking';

  /**
   * {@inheritdoc}
   */
  public static $label = 'Option';

  /**
   * {@inheritdoc}
   */
  public function view() {
    $option = $this->getOption();
    $name = $this->getNameValue();

    return [
      '#markup' => $option . ': ' . $name,
    ];
  }

  protected function getOption() {
    $option = $this->get('Option');
    return $option->getValue() ? $option->getValue() : 'N/A';
  }

  protected function getNameValue() {
    $name = $this->get('Name');
    return $name->getValue() ? $name->getValue() : 'N/A';
  }

}
