<?php

namespace Drupal\xero\TypedData;

/**
 * Describes methods useful for Xero API integration on complex data types.
 *
 * Complex data types refers to a top-level data type accessible from the API.
 *
 * @deprecated in 8.x-1.x and removed from 8.x-2.0.
 *
 * @see \Drupal\xero\TypedData\XeroComplexItemInterface
 */
interface XeroTypeInterface extends XeroComplexItemInterface {

  /**
   * Get the GUID property name.
   *
   * @return string
   *   The name of the Xero GUID field for this type.
   *
   * @deprecated in 8.x-1.x and is removed from 8.x-2.0.
   *
   * @see \Drupal\xero\Plugin\DataType\XeroComplexItemBase::getXeroProperty()
   */
  public function getGUIDName();

  /**
   * Get the Plural property name.
   *
   * @return string
   *   The plural for this type.
   *
   * @deprecated in 8.x-1.x and is removed from 8.x-2.0.
   *
   * @see \Drupal\xero\TypedData\XeroItemInterface::getXeroProperty()
   */
  public function getPluralName();

  /**
   * Get the Label property.
   *
   * @return string
   *   The Label property for this type, if any.
   *
   * @deprecated in 8.x-1.x and is removed from 8.x-2.0.
   *
   * @see \Drupal\xero\TypedData\XeroItemInterface::getXeroProperty()
   */
  public function getLabelName();

}
